package com.chinaitop.depot.storage.service.impl;

import com.chinaitop.depot.storage.mapper.StorageKeeperTransferMapper;
import com.chinaitop.depot.storage.mapper.StorageKeepertransferDetailsMapper;
import com.chinaitop.depot.storage.model.StorageKeeperTransfer;
import com.chinaitop.depot.storage.model.StorageKeeperTransferExample;
import com.chinaitop.depot.storage.model.StorageKeepertransferDetails;
import com.chinaitop.depot.storage.service.StorageKeeperTransferService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author sunhongbing
 * @Date 2017/10/24
 */
@Service
public class StorageKeeperTransferServiceImpl implements StorageKeeperTransferService {
    @Resource
    private StorageKeeperTransferMapper keeperTransferMapper;
    @Resource
    private StorageKeepertransferDetailsMapper keepertransferDetailsMapper;
    @Override
    public List<StorageKeeperTransfer> queryByKeeperTransfer(StorageKeeperTransfer keeperTransfer) {
        return keeperTransferMapper.queryByExample(keeperTransfer);
    }

    @Override
    public void save(StorageKeeperTransfer keeperTransfer) {
        if (keeperTransfer.getId() == null)
            keeperTransferMapper.insert(keeperTransfer);//新增数据
        else
            keeperTransferMapper.updateByPrimaryKey(keeperTransfer);//修改数据
    }

    @Override
    public StorageKeeperTransfer loadDataById(int id) {
        return keeperTransferMapper.selectByPrimaryKey(id);

    }

    @Override
    @Transactional
    public void remove(int id) {
        keeperTransferMapper.deleteByPrimaryKey(id);
    }

    @Override
    @Transactional
    public void add(StorageKeeperTransfer keeperTransfer, List<StorageKeepertransferDetails> keeperTransferDetailList) {
        keeperTransferMapper.insert(keeperTransfer);

        for (StorageKeepertransferDetails keeperTransferDetail : keeperTransferDetailList) {
            keeperTransferDetail.setKtId(keeperTransfer.getId());
            keepertransferDetailsMapper.insert(keeperTransferDetail);
        }
    }
}
